Package com.io7m.waxmill.machines

# Interface WXMVirtualMachineType

All Known Implementing Classes:
  `WXMVirtualMachine`

    @Immutable
    public interface WXMVirtualMachineType

A virtual machine.

- ## Method Summary

  Modifier and Type | Method | Description
  --- | --- | ---
  `default java.util.Map<WXMBootConfigurationName,​WXMBootConfigurationType>` | `bootConfigurationMap()` |
  `java.util.List<WXMBootConfigurationType>` | `bootConfigurations()` |
  `default void` | `checkPreconditions()` | Check preconditions for the type.
  `default java.lang.String` | `comment()` |
  `java.util.Optional<java.net.URI>` | `configurationFile()` |
  `default WXMCPUTopology` | `cpuTopology()` |
  `default java.util.Map<WXMDeviceSlot,​WXMDeviceType>` | `deviceMap()` |
  `java.util.List<WXMDeviceType>` | `devices()` |
  `default WXMFlags` | `flags()` |
  `java.util.UUID` | `id()` |
  `default WXMMemory` | `memory()` |
  `WXMMachineName` | `name()` |

- ## Method Details

  - ### id

    java.util.UUID id()
    Returns:
      The machine ID

  - ### name

    WXMMachineName name()
    Returns:
      The machine name

  - ### comment

    @Default default java.lang.String comment()
    Returns:
      A descriptive comment

  - ### cpuTopology

    @Default default WXMCPUTopology cpuTopology()
    Returns:
      The CPU topology

  - ### memory

    @Default default WXMMemory memory()
    Returns:
      The machine's memory configuration

  - ### devices

    java.util.List<WXMDeviceType> devices()
    Returns:
      The list of devices attached to the machine

  - ### flags

    @Default default WXMFlags flags()
    Returns:
      The machine flags

  - ### bootConfigurations

    java.util.List<WXMBootConfigurationType> bootConfigurations()
    Returns:
      The list of boot configurations associated with the machine

  - ### configurationFile

    java.util.Optional<java.net.URI> configurationFile()
    Returns:
      The configuration file path, if the VM was configured from a file

  - ### deviceMap

    @Derived @Auxiliary default java.util.Map<WXMDeviceSlot,​WXMDeviceType> deviceMap()
    Returns:
      The set of attached devices, ordered by device slot

  - ### bootConfigurationMap

    @Derived @Auxiliary default java.util.Map<WXMBootConfigurationName,​WXMBootConfigurationType> bootConfigurationMap()
    Returns:
      The set of boot configurations, ordered by name

  - ### checkPreconditions

    @Check default void checkPreconditions()
    Check preconditions for the type.